% Copyright (C) Paweł Płazieński 2009
%
% This program is free software; you can redistribute it and/or modify it
% under the terms of the GNU General Public License as published by the
% Free Software Foundation; either version 2, or (at your option) any
% later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

list_string([],S,_) :-
	S = ''.

list_string(List,String,Separator) :-
	List = [Head|Tail],
	list_string(Tail,Rest,Separator),
	string_to_atom(Element,Head),
	(  Tail = [],
		Rest = PrepRest
	;  not(Tail = []),
		string_concat(Separator,Rest,PrepRest)
	),
	string_concat(Element,PrepRest,String).

lists_strings([],[]).

lists_strings(ListifiedList,StringList) :-
	ListifiedList = [ListifiedHead|ListifiedTail],
	StringList = [StringHead|StringTail],
	string_to_list(StringHead,ListifiedHead),
	lists_strings(ListifiedTail,StringTail).

string_list(String,List,[Separator]) :-
	string_to_list(String,Listified),
	list_separated(Listified,ListifiedLists,Separator),
	lists_strings(ListifiedLists,List).

list_separated(Separated,Lists,Separator) :-
	not(member(Separator,Separated)),
	Lists = [Separated].

list_separated(Separated,Lists,Separator) :-
	append(First,[Separator|Rest],Separated),
	not(member(Separator,First)),
	list_separated(Rest,Tail,Separator),
	Lists = [First|Tail].
